/*
 *	make_gl Ver.1.00	Copyright (C) 2009  kt
 *
 *	m2v.vfp  GOP List t@C (.gl) 쐬BiChJ[hΉj
 *
 *	usage:
 *	  make_gl <mpeg2file> ...
 */

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>
#include "vfapi.h"
#include "vfapi_edit_ext.h"
#include "m2v_vfapi.h"

#define APP_NAME	"make_gl"

//int main(int argc, char *argv[])
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
		LPSTR lpCmdLine, int nCmdShow)
{
	int argc = __argc;
	char **argv = __argv;
	M2V_VFAPI m2v;
	VF_FileHandle hFileHandle;
	int i;
	
	if (argc == 1) {
		MessageBox(NULL, "usage: " APP_NAME " <mpeg2file> ...", APP_NAME,
				MB_ICONINFORMATION | MB_OK);
		return 2;
	}
	
	if (!open_m2v_vfapi(&m2v)) {
		MessageBox(NULL, "Can't open m2v.vfp.", APP_NAME,
				MB_ICONERROR | MB_OK);
		return 1;
	}
	
	for (i = 1; i < argc; i++) {
		if (m2v.func.OpenFile(argv[i], &hFileHandle) == VF_OK) {
			m2v.func.CloseFile(hFileHandle);
		}
	}
	
//	close_m2v_vfapi(&m2v);
	return 0;
}
