@echo off
rem setlocal EnableDelayedExpansion
setlocal

rem ===================================================================
echo tsconv.bat Ver.0.01   Copyright (C) 2009  kt
goto skip_usage
:usage
echo.
echo usage:
echo   tsconv INTPUT_TS.ts [OUTPUT_NAME] [-o OUTPUT_FOLDER] [options]
echo.
echo options:
echo   -nosplit         TsSplitter ŏȂ
echo   -splitopt "opt"  TsSplitter ̒ǉIvVw肷
echo   -nogl            m2v.vfp p .gl 쐬Ȃ
echo   -noaac           AAC ̒osȂ
echo   -aacopt "opt"    ts2aac ̒ǉIvVw肷
echo   -noaactool       aactool ŏȂ
echo   -nofaw           FakeAacWav ŏȂ
echo   -nocap           ̒osȂ
echo   -capopt "opt"    Caption2Ass ̒ǉIvVw肷
echo   -minsize N       TCY N  TS t@CȂ (default N=50[MB])
rem ===================================================================
goto :eof
:skip_usage

rem =========================================================
rem  Default settings
rem =========================================================

set NOSPLIT=0
set NOGL=0
set NOAAC=0
set NOAACTOOL=1
set NOFAW=0
set NOCAP=0

rem set TSSPLITTER=
rem set MAKE_GL=
rem set TS2AAC=
rem set EXEC_TS2AAC=
rem set AACTOOL=
rem set FAW=
rem set CAP2ASS=
rem set MINTSFILESIZE=

rem set EXIT_IF_ERROR=

set SPLITOPT=-1SEG -SEP
set AACOPT=
set CAPOPT=-format srt

if "%TSSPLITTER%"==""	set TSSPLITTER=TsSplitter
if "%MAKE_GL%"==""	set MAKE_GL=make_gl
if "%TS2AAC%"==""	set TS2AAC=ts2aac
if "%AACTOOL%"==""	set AACTOOL=aactool
if "%FAW%"==""		set FAW=FAW
if "%CAP2ASS%"==""	set CAP2ASS=Caption2Ass_mod1
if "%MINTSFILESIZE%"=="" set /a MINTSFILESIZE=50*1024*1024

rem =========================================================
rem  Check arguments
rem =========================================================

if "%~1"=="" goto usage
set INPUT_TS=%~f1
shift

:arg_loop
  if /i "%~1" equ "-o" (
    if "%~2"=="" goto usage
    for %%I in ("%~f2\") do set OUTPUT_FOLDER=%%~dpI
    shift
  ) else if /i "%~1" equ "-minsize" (
    if "%~2"=="" goto usage
    set /a MINTSFILESIZE=%2*1024*1024
    shift
  ) else if /i "%~1" equ "-splitopt" (
    if "%~2"=="" goto usage
    set SPLITOPT=%~2
    shift
  ) else if /i "%~1" equ "-aacopt" (
    if "%~2"=="" goto usage
    set AACOPT=%~2
    shift
  ) else if /i "%~1" equ "-capopt" (
    if "%~2"=="" goto usage
    set CAPOPT=%~2
    shift
  ) else if /i "%~1" equ "-nosplit" (
    set NOSPLIT=1
  ) else if /i "%~1" equ "-nogl" (
    set NOGL=1
  ) else if /i "%~1" equ "-noaac" (
    set NOAAC=1
  ) else if /i "%~1" equ "-noaactool" (
    set NOAACTOOL=1
  ) else if /i "%~1" equ "-nofaw" (
    set NOFAW=1
  ) else if /i "%~1" equ "-nocap" (
    set NOCAP=1
  ) else (
    set OUTPUT_BASE_NAME=%~nx1
    if "%OUTPUT_FOLDER%"=="" set OUTPUT_FOLDER=%~dp1
  )
  shift
  if not "%~1"=="" goto arg_loop
:arg_loop_end

if "%OUTPUT_FOLDER%"=="" (
  for %%I in ("%INPUT_TS%") do set OUTPUT_FOLDER=%%~dpI
)
if "%OUTPUT_BASE_NAME%"=="" (
  for %%I in ("%INPUT_TS%") do set OUTPUT_BASE_NAME=%%~nI
)
set OUTPUT_NAME=%OUTPUT_FOLDER%%OUTPUT_BASE_NAME%

call :IsFolder "%OUTPUT_FOLDER%"
if %ERRORLEVEL% neq 0 (
  echo folder not found: %OUTPUT_FOLDER%
  goto :eof
)
for %%I in ("%INPUT_TS%") do set INPUT_NAME=%%~dpnI

rem echo.
rem echo INPUT_TS=%INPUT_TS%
rem echo OUTPUT_BASE_NAME=%OUTPUT_BASE_NAME%
rem echo OUTPUT_FOLDER=%OUTPUT_FOLDER%
rem echo OUTPUT_NAME=%OUTPUT_NAME%
rem echo.

rem pause

rem =========================================================
rem  Main
rem =========================================================

if %NOSPLIT% equ 0 (
  rem --------------------
  rem  TsSplitter
  rem --------------------
  echo.
  echo ===^>^> TS t@C𕪗
  "%TSSPLITTER%" -EIT -ECM -EMM %SPLITOPT% -out "%OUTPUT_FOLDER:~0,-1%" "%INPUT_TS%"
  if ERRORLEVEL 1 (
    echo.
    echo ===^>^> TsSplitter failed.
    if defined %EXIT_IF_ERROR% exit else exit /b
  )
  
  for %%I in ("%OUTPUT_NAME%_HD*.ts" "%OUTPUT_NAME%_SD*.ts") do (
    call :CheckFileSize "%%I" %MINTSFILESIZE%
    if NOT ERRORLEVEL 1 (
      call :make_gl "%%I"
      call :ts2aac "%%I"
      call :Caption2Ass "%%I"
    )
  )
) else (
  rem --------------------
  rem  No TsSplitter
  rem --------------------
  if /i "%INPUT_TS%" neq "%OUTPUT_NAME%.ts" (
    echo.
    echo ===^>^> TS t@CRs[
    copy /y "%INPUT_TS%" "%OUTPUT_NAME%.ts"
  )
  if exist "%OUTPUT_NAME%.ts" (
    call :make_gl "%OUTPUT_NAME%.ts"
    call :ts2aac "%OUTPUT_NAME%.ts"
    call :Caption2Ass "%OUTPUT_NAME%.ts"
  ) else (
    echo.
    echo ===^>^> File not found.
    if defined %EXIT_IF_ERROR% exit else exit /b
  )
)
echo.
echo ===^>^> 
goto :eof



rem =========================================================
rem  make_gl
rem =========================================================
:make_gl
if %NOGL% equ 0 (
  echo.
  echo ===^>^> .gl t@C쐬
  start "" /wait "%MAKE_GL%" %1
)
exit /b


rem =========================================================
rem  ts2aac
rem =========================================================
:ts2aac
if %NOAAC% neq 0 (
  goto :eof
)
setlocal
set OUTPUT_AAC=%~dpn1
for %%I in (0 1) do (
  echo.
  echo ===^>^> AAC 𒊏o ^(ES #%%I^)
  %EXEC_TS2AAC% "%TS2AAC%" -i %1 -o "%OUTPUT_AAC%" -e %%I %AACOPT%
)
for %%I in ("%OUTPUT_AAC% PID * DELAY *.aac") do (
  call :aactool "%OUTPUT_AAC%" "%%I"
)
exit /b


rem =========================================================
rem  aactool
rem =========================================================
:aactool
if %NOAACTOOL% neq 0 (
  shift
  goto FakeAacWav
)
setlocal
set INPUT_AAC=%~2
set OUTPUT_AAC=%~1
call set OUTPUT_AAC=%OUTPUT_AAC%_fix%%INPUT_AAC:%OUTPUT_AAC%=%%

echo INPUT_AAC=%INPUT_AAC%
echo OUTPUT_AAC=%OUTPUT_AAC%

"%AACTOOL%" -i "%INPUT_AAC%" -o "%OUTPUT_AAC%"
call :FakeAacWav "%OUTPUT_AAC%"
exit /b


rem =========================================================
rem  FakeAacWav
rem =========================================================
:FakeAacWav
if %NOFAW% equ 0 (
  echo.
  echo ===^>^> ^ WAV ɕϊ
  start "" /wait "%FAW%" %1
)
exit /b


rem =========================================================
rem  Caption2Ass
rem =========================================================
:Caption2Ass
setlocal
set capfile="%~dpn1.srt"
if %NOCAP% equ 0 (
  echo.
  echo ===^>^> 𒊏o
  "%CAP2ASS%" -silent %CAPOPT% %1
  if exist %capfile% (
    for %%I in (%capfile%) do if %%~zI equ 3 (
      rem .srt ̃t@CTCY 3bytes ̏ꍇ
      del %capfile%
    )
  )
)
exit /b





goto :eof
rem =========================================================
rem  support routines
rem =========================================================

:GetLargestFile
set maxsize=0
for %%I in ("%~1") do call :GetLargestFile_sub %%~zI "%%I"
goto :eof

:GetLargestFile_sub
if %1 geq %maxsize% (
  set maxsize=%1
  set maxfile=%~2
)
goto :eof

rem :IsFolder <Path>
:IsFolder
setlocal
for %%I in ("%~1") do set attr=%%~aI
if not "%attr:~0,1%"=="d" (
  rem Not a folder
  exit /b 1
)
exit /b 0

rem :CheckFileSize <FileName> <MinFileSize>
:CheckFileSize
for %%I in ("%~1") do (
  if %%~zI geq %2 (
    exit /b 0
  )
  exit /b 1
)

